Loading...
Searching...
No Matches
casacore::CurvedLattice2D< T > Class Template Reference
lattices package (libcasa_lattices) » Lattices_module » Lattices_module_internal_classes

More...

`#include <CurvedLattice2D.h>`

## Public Member Functions

| CurvedLattice2D ()
| Default constructor.
| CurvedLattice2D (const MaskedLattice< T > &, const CLInterpolator2D< T > &, const PixelCurve1D &, uInt axis1, uInt axis2, Int curveAxis=-1)
| Take a curved slice from the given MaskedLattice.
| CurvedLattice2D (const CurvedLattice2D< T > &other)
| Copy constructor (reference semantics).
virtual | ~CurvedLattice2D ()
| Destructor, does nothing.
CurvedLattice2D< T > & | operator= (const CurvedLattice2D< T > &other)
| Assignment (reference semantics).
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the object (reference semantics).
virtual Bool | isMasked () const
| Is the lattice masked?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual Bool | isWritable () const
| The lattice is not writable.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle ocking of the lattice which is delegated to its parent.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data.
virtual void | tempClose ()
| Close the Lattice temporarily (if it is paged to disk).
virtual void | reopen ()
| If needed, reopen a temporarily closed Lattice.
virtual const LatticeRegion * | getRegionPtr () const
| Get a pointer the region/mask object.
virtual IPosition | shape () const
| Returns the shape of the lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the parent lattice.
virtual uInt | advisedMaxPixels () const
| This function returns the recommended maximum number of pixels to include in the cursor of an iterator.
virtual Bool | ok () const
| Check class internals - used for debugging.
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual getting of an array of values.
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Get a section of the mask.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Get the best cursor shape.
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
virtual Bool | hasPixelMask () const
| Does the lattice have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask.
virtual Lattice< Bool > & | pixelMask ()
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Member Functions

void | makeMapping (uInt axis1, uInt axis2, Int curveAxis)
| Make the AxesMapping object to map input to output axes.

## Private Attributes

MaskedLattice< T > * | itsLatticePtr
CLInterpolator2D< T > * | itsInterpolator
PixelCurve1D | itsCurve
uInt | itsAxis1
uInt | itsAxis2
uInt | itsCurveAxis
AxesMapping | itsAxesMap

## Additional Inherited Members

Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

template<class T>
class casacore::CurvedLattice2D< T >

A lattice crosscut based on a curve in a plane.

### Intended use:

Internal

### Review Status

Test programs:
  tCurvedLattice2D

### Prerequisite

- PixelCurve1D
- CLInterpolator2D

### Synopsis

Class CurvedImage2D can be used to make a crosscut through an image with a dimensionality >= 2. The crosscut is based on a curve defined by a PixelCurve1D object. The curve can be any 1-dim function (e.g. straight line, spline) supported by the Functionals module. The curve must be in one of the main planes of the image as defined by the axes arguments in the constructor.
See class CurvedImage2D for a more detailed description.

### Example

See example in CurvedImage2D.

### Motivation

Users like to view arbitrary image crosscuts.

Definition at line 80 of file CurvedLattice2D.h.

## Constructor & Destructor Documentation

## CurvedLattice2D() [1/3]

template<class T>

casacore::CurvedLattice2D< T >::CurvedLattice2D | ( |  | ) |

Default constructor.

Referenced by CurvedLattice2D(), and operator=().

## CurvedLattice2D() [2/3]

template<class T>

casacore::CurvedLattice2D< T >::CurvedLattice2D | ( | const MaskedLattice< T > & | ,
|  | const CLInterpolator2D< T > & | ,
|  | const PixelCurve1D & | ,
|  | uInt | axis1,
|  | uInt | axis2,
|  | Int | curveAxis = -1 )

Take a curved slice from the given MaskedLattice.

For example, define a spline in the RA-DEC plane and extend it in the FREQ direction. The result is a 2D lattice with axes FREQ and 'spline'.
The PixelCurve1D object defines the curve in one of the planes of the lattice. The arguments axis1 and axis2 define the plane the curve is in. The CLInterpolator2D object defines the interpolation scheme for pixels that are not on grid points. An example is CLIPNearest2D which takes the nearest neighbour. The dimensionality of the CurvedLattice2D is one less than the dimensionality of the given lattice. Two axes (axis1 and axis2) are replaced by the new axis representing the curve. The argument curveAxis defines the axis number of the new axis. It defaults to the last axis. An exception is thrown if the dimensionality of the input lattice is < 2 or if the given axes numbers are too high.

References casacore::MaskedLattice< T >::MaskedLattice().

## CurvedLattice2D() [3/3]

template<class T>

casacore::CurvedLattice2D< T >::CurvedLattice2D | ( | const CurvedLattice2D< T > & | other | ) |

Copy constructor (reference semantics).

References CurvedLattice2D().

## ~CurvedLattice2D()

template<class T>

virtual casacore::CurvedLattice2D< T >::~CurvedLattice2D | ( |  | ) |

virtual

Destructor, does nothing.

## Member Function Documentation

## advisedMaxPixels()

template<class T>

virtual uInt casacore::CurvedLattice2D< T >::advisedMaxPixels | ( |  | ) | const

virtual

This function returns the recommended maximum number of pixels to include in the cursor of an iterator.

Reimplemented from casacore::Lattice< T >.

## cloneML()

template<class T>

virtual MaskedLattice< T > * casacore::CurvedLattice2D< T >::cloneML | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::MaskedLattice< T >.

References casacore::MaskedLattice< T >::MaskedLattice().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Get a section of the mask.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::CurvedLattice2D< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Get the best cursor shape.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::CurvedLattice2D< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< T >.

## flush()

template<class T>

virtual void casacore::CurvedLattice2D< T >::flush | ( |  | ) |

virtual

Flush the data.

Reimplemented from casacore::LatticeBase.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::CurvedLattice2D< T >::getRegionPtr | ( |  | ) | const

virtual

Get a pointer the region/mask object.

It returns 0.

Implements casacore::MaskedLattice< T >.

## hasLock()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## isMasked()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::isMasked | ( |  | ) | const

virtual

Is the lattice masked?

It is if its parent lattice is masked.

Reimplemented from casacore::MaskedLattice< T >.

## isPaged()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::isPaged | ( |  | ) | const

virtual

Is the lattice paged to disk?

Reimplemented from casacore::LatticeBase.

## isWritable()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::isWritable | ( |  | ) | const

virtual

The lattice is not writable.

Reimplemented from casacore::LatticeBase.

## lock()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle ocking of the lattice which is delegated to its parent.

It is strongly recommended to use class LatticeLocker to handle lattice locking. It also contains a more detailed explanation of the locking process.

Reimplemented from casacore::LatticeBase.

## makeMapping()

template<class T>

void casacore::CurvedLattice2D< T >::makeMapping | ( | uInt | axis1,
|  | uInt | axis2,
|  | Int | curveAxis )

private

Make the AxesMapping object to map input to output axes.

## name()

template<class T>

virtual String casacore::CurvedLattice2D< T >::name | ( | Bool | stripPath = False | ) | const

virtual

Return the name of the parent lattice.

Reimplemented from casacore::LatticeBase.

References casacore::False.

## ok()

template<class T>

virtual Bool casacore::CurvedLattice2D< T >::ok | ( |  | ) | const

virtual

Check class internals - used for debugging.

Should always return True

Reimplemented from casacore::LatticeBase.

## operator=()

template<class T>

CurvedLattice2D< T > & casacore::CurvedLattice2D< T >::operator= | ( | const CurvedLattice2D< T > & | other | ) |

Assignment (reference semantics).

References CurvedLattice2D().

## reopen()

template<class T>

virtual void casacore::CurvedLattice2D< T >::reopen | ( |  | ) |

virtual

If needed, reopen a temporarily closed Lattice.

Reimplemented from casacore::LatticeBase.

## resync()

template<class T>

virtual void casacore::CurvedLattice2D< T >::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.

Reimplemented from casacore::LatticeBase.

## shape()

template<class T>

virtual IPosition casacore::CurvedLattice2D< T >::shape | ( |  | ) | const

virtual

Returns the shape of the lattice.

Implements casacore::LatticeBase.

## tempClose()

template<class T>

virtual void casacore::CurvedLattice2D< T >::tempClose | ( |  | ) |

virtual

Close the Lattice temporarily (if it is paged to disk).

It'll be reopened automatically when needed or when reopen is called explicitly.

Reimplemented from casacore::LatticeBase.

## unlock()

template<class T>

virtual void casacore::CurvedLattice2D< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## itsAxesMap

template<class T>

AxesMapping casacore::CurvedLattice2D< T >::itsAxesMap

private

Definition at line 202 of file CurvedLattice2D.h.

## itsAxis1

template<class T>

uInt casacore::CurvedLattice2D< T >::itsAxis1

private

Definition at line 199 of file CurvedLattice2D.h.

## itsAxis2

template<class T>

uInt casacore::CurvedLattice2D< T >::itsAxis2

private

Definition at line 200 of file CurvedLattice2D.h.

## itsCurve

template<class T>

PixelCurve1D casacore::CurvedLattice2D< T >::itsCurve

private

Definition at line 198 of file CurvedLattice2D.h.

## itsCurveAxis

template<class T>

uInt casacore::CurvedLattice2D< T >::itsCurveAxis

private

Definition at line 201 of file CurvedLattice2D.h.

## itsInterpolator

template<class T>

CLInterpolator2D<T>* casacore::CurvedLattice2D< T >::itsInterpolator

private

Definition at line 197 of file CurvedLattice2D.h.

## itsLatticePtr

template<class T>

MaskedLattice<T>* casacore::CurvedLattice2D< T >::itsLatticePtr

private

Definition at line 196 of file CurvedLattice2D.h.

The documentation for this class was generated from the following files:

- images/Images/CurvedImage2D.h
- lattices/Lattices/CurvedLattice2D.h